/**
  ******************************************************************************
  * @file    vkl128.c
  * @author  kevin_guo
  * @version V1.2
  * @date    05-17-2020
  * @brief   This file contains all the vkl128 functions. 
	*          ļ VKl128
  ******************************************************************************
  * @attention
  ******************************************************************************
  */	
/* Includes ------------------------------------------------------------------*/
#include "vkl128.h"
  
/* extern variables ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define VKl128_CLK 10 //SCLźƵ,delay_nusʵ 50->10kHz 10->50kHz 5->100kHz
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
//segtab[]ӦʵʵоƬLCDߣ߼-VKl128ο·
unsigned char vkl128_segtab[Vkl128_SEGNUM]={
	0,1,2,3,4,5,6,7,8,9,						//SEG0-SEG9
	10,11,12,13,14,15,16,17,18,19,	//SEG10-SEG19
	20,21,22,23,24,25,26,27,28,29,	//SEG20-SEG29
	30,31														//SEG30-SEG31
};
//LCDʵֻSEG10SEG21ʹ
//.hļVKl128_SEGNUM=12
//const unsigned char vkl128_segtab[VKl128_SEGNUM]={	
//	10,11,12,13,14,15,16,17,18,19,	//SEG10-SEG19
//	20,21,													//SEG20-SEG21
//};
//vkl128_dispramӦоƬʾRAM
unsigned char vkl128_dispram[Vkl128_SEGNUM/2];//ÿֽݶӦ2SEG
//Ӧvkl128_segtab[VKl128_SEGNUM]
//ʾRAM bufferΪ8λӦ2SEGbit7/bit3->com3,bit6/bit2->com2,bit5/bit1->com1,bit4/bit0->com0
//LCD ʵ  38
//1ǰλ2ʮλ3Ǹλ
/*ʾbufferlcdͼӳϵ
vkl128_dispram[VKl128_SEGNUM/2]=
{//com3   com2   com1     com0 //ӦоƬSEG  ӦʾRAM
	1D,     1E,    1F,      1A,     //seg0   			vkl128_dispram[0]-bit3-bit0
	  ,     1C,    1G,      1B,     //seg1				vkl128_dispram[0]-bit7-bit4
	2D,     2E,    2F,      2A,     //seg2				vkl128_dispram[1]-bit3-bit0
	  ,     2C,    2G,      2B,     //seg3				vkl128_dispram[1]-bit7-bit4
	3D,     3E,    3F,      3A,		  //seg4				vkl128_dispram[2]-bit3-bit0
	  ,     3C,    3G,      3B,			//seg5				vkl128_dispram[2]-bit7-bit4
}
*/
/*8ֵ 
     A
   F   B
     G
	 E   C
	   D
*/
unsigned char shuzi_zimo[15]= //ַֺģ
{
//0    1    2    3    4    5    6    7    8    9    -    L    o    H    i 
	0x5F,0x50,0x3D,0x79,0x72,0x6B,0x6F,0x51,0x7F,0x7B,0x20,0x0E,0x6C,0x76,0x50
};
unsigned char vkl128_segi,vkl128_comi;
unsigned char vkl128_maxcom;//com4com
/* Private function prototypes -----------------------------------------------*/
unsigned char Vkl128_InitSequence(void);
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}
/*******************************************************************************
* Function Name  : delay_nms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nms(unsigned long int n)
{
	while(n--)
	{
		delay_nus(1000);
	}
}
/*******************************************************************************
* Function Name  : I2CStart
* Description    : ʱ߸ʱɸߵ͵䣬ʾI2Cʼź
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl128_I2CStart( void )
{
  Vkl128_SCL_H();
  Vkl128_SDA_H();
  delay_nus(VKl128_CLK);
  Vkl128_SDA_L();
  delay_nus(VKl128_CLK);
}
/*******************************************************************************
* Function Name  : I2CStop
* Description    : ʱ߸ʱɵ͵ߵ䣬ʾI2Cֹͣź
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl128_I2CStop( void )
{
  Vkl128_SCL_H();
  Vkl128_SDA_L();
  delay_nus(VKl128_CLK);
  Vkl128_SDA_H();
  delay_nus(VKl128_CLK);
}
/*******************************************************************************
* Function Name  : I2CSlaveAck
* Description    : I2Cӻ豸Ӧѯ
* Input          : None
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char Vkl128_I2CSlaveAck( void )
{
  unsigned int TimeOut;
  unsigned char RetValue;
	
  Vkl128_SCL_L();
	//ƬSDAΪIOҪΪ
	Vkl128_SET_SDA_IN();
  delay_nus(VKl128_CLK);
  Vkl128_SCL_H();//9sclk

  TimeOut = 10000;
  while( TimeOut-- > 0 )
  {
    if( Vkl128_GET_SDA()!=0 )//ȡack
    {
      RetValue = 1;
    }
    else
    {
      RetValue = 0;
      break;
    }
  } 
	Vkl128_SCL_L();
	//ƬSDAΪIOҪΪ
	Vkl128_SET_SDA_OUT();  
  
  return RetValue;
}
/*******************************************************************************
* Function Name  : I2CCmdByte
* Description    : I2Cдһֽ,͸λ
* Input          : byte-Ҫд
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl128_I2CCmdByte( unsigned char byte )
{
	unsigned char i=8;
	while (i--)
	{ 
		Vkl128_SCL_L();
		if(byte&0x80)
			Vkl128_SDA_H();
		else
			Vkl128_SDA_L();
		byte<<=1; 
		delay_nus(VKl128_CLK);
		Vkl128_SCL_H();     
		delay_nus(VKl128_CLK);
	}
}
/*******************************************************************************
* Function Name  : I2CDatByte
* Description    : I2Cдһֽ,͵λ
* Input          : byte-Ҫд
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl128_I2CDatByte( unsigned char byte )
{
	unsigned char i=8;
	while (i--)
	{ 
		Vkl128_SCL_L();
		if(byte&0x01)
			Vkl128_SDA_H();
		else
			Vkl128_SDA_L();
		byte>>=1; 
		delay_nus(VKl128_CLK);
		Vkl128_SCL_H();     
		delay_nus(VKl128_CLK);
	}
}
/*******************************************************************************
* Function Name  : Write1Data
* Description    : д1ֽݵʾRAM
* Input          : Addr-дramĵַ
*                : Dat->дram
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char Write1DataVkl128(unsigned char Addr,unsigned char Dat)
{
	//START ź
	Vkl128_I2CStart(); 
	//SLAVEַ
	Vkl128_I2CCmdByte(Vkl128_ADDR); 
	if( 1 == Vkl128_I2CSlaveAck() )
	{		
		Vkl128_I2CStop();
		return 1; 
	}
	//ʾRAMַ
	if(Addr>0x1f)
		Vkl128_I2CCmdByte(Vkl128_ADDR5_1); 
	else
		Vkl128_I2CCmdByte(Vkl128_ADDR5_0); 
	if( 1 == Vkl128_I2CSlaveAck() )
	{
		Vkl128_I2CStop();
		return 1;
	}
	Vkl128_I2CCmdByte(Addr&0x1f); 
	if( 1 == Vkl128_I2CSlaveAck() )
	{
		Vkl128_I2CStop();
		return 1;
	}
	//ʾݣ1ֽݰ2SEG
	Vkl128_I2CDatByte(Dat);
	if( Vkl128_I2CSlaveAck()==1 )
	{
		Vkl128_I2CStop();
		return 1;
	}
	//STOPź
 Vkl128_I2CStop();
 return 0;   
}
/*******************************************************************************
* Function Name  : WritenData
* Description    : дݵʾRAM
* Input          : Addr-дramʼַ
*                : Databuf->дrambufferָ
*                : Cnt->дramݸ
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char  WritenDataVkl128(unsigned char Addr,unsigned char *Databuf,unsigned char Cnt)
{
	unsigned char n;
	
	//STARTź	
	Vkl128_I2CStart(); 									
	//SLAVEַ
	Vkl128_I2CCmdByte(Vkl128_ADDR); 	
	if( 1 == Vkl128_I2CSlaveAck() )
	{
		Vkl128_I2CStop();													
		return 0;										
	}
	//ʾRAMʼַ
	if(Addr>0x1f)
		Vkl128_I2CCmdByte(Vkl128_ADDR5_1); 
	else
		Vkl128_I2CCmdByte(Vkl128_ADDR5_0); 
	if( 1 == Vkl128_I2CSlaveAck() )
	{
		Vkl128_I2CStop();													
		return 0; 
	}
	Vkl128_I2CCmdByte(Addr&0x1f); 						
	if( 1 == Vkl128_I2CSlaveAck() )
	{
		Vkl128_I2CStop();													
		return 0;
	}
	//CntݵʾRAM
	for(n=0;n<Cnt;n++)
	{ 
		Vkl128_I2CDatByte(*Databuf++);
		if( Vkl128_I2CSlaveAck()==1 )
		{
			Vkl128_I2CStop();													
			return 0;
		}
	}
	//STOPź
	 Vkl128_I2CStop();											
	 return 0;    
}
/*******************************************************************************
* Function Name  : Vkl128_DisAll
* Description    : SEGʾͬһݣbit7/bit3-COM3 bit6/bit2-COM2 bit5/bit1-COM1 bit4/bit0-COM0
* 					     : 磺0xffȫ 0x00ȫ 0x55 0xaa 0x33 
* Input          dat->дram(1ֽݶӦ2SEG)  
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl128_DisAll(unsigned char dat)
{
	unsigned char segi;
	unsigned char dispram[16];
	
	for(segi=0;segi<16;segi++)
	{
		dispram[segi]=dat;
	}
	WritenDataVkl128(0,dispram,16);//8bitݶӦ2SEGÿ4bitݵַ1ÿ8λ1ACK
}
/*******************************************************************************
* Function Name  : DisSegComOn
* Description    : 1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl128_DisSegComOn(unsigned char seg,unsigned char com)
{
		Write1DataVkl128(seg,(1<<(com)));//8λݵ4bitЧÿ4bitݵַ1ÿ8λ1ACK
}
/*******************************************************************************
* Function Name  : DisSegComOff
* Description    : ر1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl128_DisSegComOff(unsigned char seg,unsigned char com)
{
		Write1DataVkl128(seg,~(1<<com));//8λݵ4bitЧÿ4bitݵַ1ÿ8λ1ACK
}
/*******************************************************************************
* Function Name  : Enter_Standby
* Description    : ͹ģʽ,ʾ
* Input          None 
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char Vkl128_Enter_Standby(void)
{		
	Vkl128_I2CStart();
	Vkl128_I2CCmdByte(Vkl128_ADDR); 
	if( 1 == Vkl128_I2CSlaveAck() )
	{
		Vkl128_I2CStop();
		return 1; 
	}
	Vkl128_I2CCmdByte(Vkl128_MODESET_1_3_OFF);		//ʾ 1/3bias
//		Vkl128_I2CCmdByte(Vkl128_MODESET_1_2_OFF);	//ʾ 1/2bias
	if( 1 == Vkl128_I2CSlaveAck() )
	{
		Vkl128_I2CStop();
		return 1; 
	}
	Vkl128_I2CStop();
  return 0; 
}
/*******************************************************************************
* Function Name  : Exit_Standby
* Description    : ˳͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
unsigned char Vkl128_Exit_Standby(void)
{	
	unsigned char errorflag; //־λ1Ϊ0Ϊȷ
	
	//˳͹״̬vkl128	
	errorflag=Vkl128_InitSequence();
	
  return(errorflag);
}

/*******************************************************************************
* Function Name  : InitSequence
* Description    : ʼʱ
* Input          None 
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char Vkl128_InitSequence(void)
{		
	unsigned char n;
	
	vkl128_maxcom=4;
  //ϵʼʱ	
	//ϵ100uSڳʼ
  delay_nus(100);
	//STOPź
	Vkl128_I2CStop();
	//STARTź
	Vkl128_I2CStart();
	//SLAVEַ
	Vkl128_I2CCmdByte(Vkl128_ADDR); 
	if( 1 == Vkl128_I2CSlaveAck() )
	{
		Vkl128_I2CStop();	
		return 1;
	}
	//λ
	Vkl128_I2CCmdByte(Vkl128_SOFTRST);
	if( 1 == Vkl128_I2CSlaveAck() )
	{
		Vkl128_I2CStop();	
		return 1;
	}
	//ͬĹģʽһcomҲһ
//	Vkl128_I2CCmdByte(Vkl128_DISCTL|Vkl128_FRNOR|Vkl128_SRNOR|Vkl128_LINER );  //ϵĬ VDD=5V:<29uA  VDD=3.3V:<21uA 
	Vkl128_I2CCmdByte(Vkl128_DISCTL|Vkl128_FRPM3|Vkl128_SRPM1|Vkl128_FRAMER);  //ʡ VDD=5V:<12.7uA  VDD=3.3V:<8.5uA 
//	Vkl128_I2CCmdByte(Vkl128_DISCTL|Vkl128_FRPM1|Vkl128_SRPM1|Vkl128_FRAMER);  // VDD=5V:<13uA  VDD=3.3V:<9uA 
	if( 1 == Vkl128_I2CSlaveAck() )
	{
		Vkl128_I2CStop();	
		return 1;
	}
	//ӳʼַ bit5=0
	Vkl128_I2CCmdByte(Vkl128_ADDR5_0); //SEG32-SEG63ַ	
	if( 1 == Vkl128_I2CSlaveAck() )
	{
		Vkl128_I2CStop();	
		return 1;
	} 
	//ӳʼַ bit4~bit0=0
	Vkl128_I2CCmdByte(Vkl128_ADSET);//SEG0-SEG31ַ
	if( 1 == Vkl128_I2CSlaveAck() )
	{
		Vkl128_I2CStop();	
		return 1;
	}
	//ʾݣÿֽڰ2seg
	for(n=0;n<Vkl128_SEGNUM/2;n++)  
	{ 
		Vkl128_I2CDatByte(0x00);    // ʼʾڴ,޸. 
		if( Vkl128_I2CSlaveAck()==1 )
		{
			Vkl128_I2CStop();	
			return 1;
		}
	}
	//STOPź
	Vkl128_I2CStop(); 
  //STARTź  
	Vkl128_I2CStart();
	//SLAVEַ
	Vkl128_I2CCmdByte(Vkl128_ADDR);
	if( 1 == Vkl128_I2CSlaveAck() )
	{
		Vkl128_I2CStop();	
		return 1;
	}
  //ʾģʽʾ
	Vkl128_I2CCmdByte(Vkl128_MODESET_1_3_ON);		//ʾ 1/3bias
//		Vkl128_I2CCmdByte(Vkl128_MODESET_1_2_ON);	//ʾ 1/2bias
	if( 1 == Vkl128_I2CSlaveAck() )
	{
		Vkl128_I2CStop();	
		return 1;
	}
	Vkl128_I2CStop();	
		
  return  0; 
}
/*******************************************************************************
* Function Name  : Lowlevel_Init
* Description    : ͨGPIO
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl128_Lowlevel_Init(void)
{
	//ͨߵƽͬӵƽת·
	//˺ݿͻƬӦ޸	
	Vkl128_SET_SDA_DIR();
	GPIO_SetMode(Vkl128_SCL_PORT, Vkl128_SCL_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(Vkl128_SDA_PORT, Vkl128_SDA_PIN, GPIO_MODE_QUASI);
		    
	Vkl128_SCL_H();  
	Vkl128_SDA_H(); 	
}
/*******************************************************************************
* Function Name  : Init
* Description    : ʼ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl128_Init(void)
{	
	//ܽøݿͻƬӦ޸
	Vkl128_Lowlevel_Init();
	//ʼʱ
	Vkl128_InitSequence();
}
/*******************************************************************************
* Function Name  : disp_3num
* Description    : ʾ3λ
* Input          dat->3λ ʮ 
* Output         : None
* Return         : None
*******************************************************************************/
void disp_3num(unsigned int dat)
{		
	unsigned dat8;
	
	dat8=dat/100%10;	//ʾλ
	vkl128_dispram[0]&=0x7f;
	vkl128_dispram[0]|=shuzi_zimo[dat8];
	
	dat8=dat/10%10; 	//ʾʮλ
	vkl128_dispram[1]&=0x7f;
	vkl128_dispram[1]|=shuzi_zimo[dat8];
	
	dat8=dat%10;			//ʾλ
	vkl128_dispram[2]&=0x7f;
	vkl128_dispram[2]|=shuzi_zimo[dat8];
		
	if(dat<100)				//С100λʾ
	{
		vkl128_dispram[0]&=0x7f;
	}
	if(dat<10) 	//С10ʮλʾ
	{
		vkl128_dispram[1]&=0x7f;
	}
	//SEG11
//	Write1DataVkl128(0,vkl128_dispram[0]);
//	Write1DataVkl128(1,vkl128_dispram[1]);
//	Write1DataVkl128(2,vkl128_dispram[2]);
	//SEGͶ
	WritenDataVkl128(0,&vkl128_dispram[0],3);
}	
/*******************************************************************************
* Function Name  : test_Main
* Description    : 
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl128_Main(void)
{	
	Vkl128_Init();
	Vkl128_DisAll(0x00);
	while(1)
	{
		Vkl128_DisAll(0xff);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vkl128_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		disp_3num(123);           //ʾ123
		delay_nms(3000);					//ʱ3S
		
		Vkl128_DisAll(0x00);			//LCDȫ
		for(vkl128_segi=0;vkl128_segi<Vkl128_SEGNUM;vkl128_segi++)//seg
		{
			for(vkl128_comi=0;vkl128_comi<vkl128_maxcom;vkl128_comi++)//com
			{
				Vkl128_DisSegComOn(vkl128_segtab[vkl128_segi],vkl128_comi);	//LCD
				delay_nms(300);				//ʱ300mS
				Vkl128_DisAll(0x00);	//LCDȫ
			}
		}
		
		Vkl128_DisAll(0xff);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		for(vkl128_segi=0;vkl128_segi<Vkl128_SEGNUM;vkl128_segi++)//seg
		{
			for(vkl128_comi=0;vkl128_comi<vkl128_maxcom;vkl128_comi++)//com
			{
				Vkl128_DisSegComOff(vkl128_segtab[vkl128_segi],vkl128_comi);	//LCDر
				delay_nms(300);				//ʱ300mS
				Vkl128_DisAll(0xff);	//LCDȫ
			}
		}
		delay_nms(1000);					//ʱ1S
		
		Vkl128_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vkl128_Enter_Standby();		//͹ģʽ
		delay_nms(5000);					//ʱ5S
		
		Vkl128_Exit_Standby();		//˳͹ģʽ
	}
}
/************************END OF FILE****/
