/**
  ******************************************************************************
  * @file    vkl128.h 
  * @author  kevin_guo
  * @version V1.2
  * @date    05-17-2020
  * @brief   Header files for Vkl128
  ******************************************************************************
  * @attention
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __VKl128_H
#define __VKl128_H

/* Includes ------------------------------------------------------------------*/
//˰ļݿͻƬӦ޸
#include "M451Series.h"
/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported define -----------------------------------------------------------*/
//
#define Vkl128_ADDR   					0x7c    // IICַ
//#define Vkl128_ICSET       			0xe8    // IC  bit0ʱԴ  bit1λ      bit2ӳַbit5
//																				// ĬΪ0 ڲRC  ִλ  
#define Vkl128_SOFTRST       		0xea    //ִλ   
#define Vkl128_ADDR5_0       		0xe8    //ӳַbit5 
#define Vkl128_ADDR5_1       		0xec    //ӳַbit5 
#define Vkl128_ADSET       			0x00    //ӳַbit4-0 
#define Vkl128_MODESET_1_3_ON  	0xc8    // ʾ 1/3bias
#define Vkl128_MODESET_1_3_OFF 	0xc0    // رʾ 1/3bias
#define Vkl128_MODESET_1_2_ON  	0xcc    // ʾ 1/2bias
#define Vkl128_MODESET_1_2_OFF 	0xc4    // رʾ 1/2bias
//ʾ
#define Vkl128_DISCTL			      0xA0  	//bit7~bit5=101 
//bit4-bit3ʡģʽFR bit2LINE,FRAME bit1-bit0ʡģʽSR
//Inor=1  Im1=0.5Inor  Im2=0.67Inor  Ihp=1.8Inor
//ʡģʽFR
#define Vkl128_FRNOR       0x00  //bit4-bit3=00   FR NORMAL 					ϵĬ 
#define Vkl128_FRPM1       0x08  //bit4-bit3=01   FR POWER SAVE MODE1
#define Vkl128_FRPM2       0x10  //bit4-bit3=10   FR POWER SAVE MODE2
#define Vkl128_FRPM3       0x18  //bit4-bit3=11   FR POWER SAVE MODE3 ʡ
//ʡģʽSR
#define Vkl128_SRHP        0x03  //bit1-bit0=11   SR NORMAL 
#define Vkl128_SRNOR       0x02  //bit1-bit0=10   SR POWER SAVE MODE1 ϵĬ 
#define Vkl128_SRPM2       0x01  //bit1-bit0=01   SR POWER SAVE MODE2
#define Vkl128_SRPM1       0x00  //bit1-bit0=00   SR POWER SAVE MODE1 ʡ
//LINE FRAME
#define Vkl128_LINER       0x00  //bit2=0   LINEת	ϵĬ
#define Vkl128_FRAMER      0x04  //bit2=1   FRAMEת ʡ
//ʾ
//Vkl128_FRPM1|Vkl128_SRPM1|Vkl128_FRAMER    //
//Vkl128_FRPM2|Vkl128_SRPM1|Vkl128_FRAMER    //
//Vkl128_FRPM3|Vkl128_SRPM1|Vkl128_FRAMER    //ʡ
//Vkl128_FRNOR|Vkl128_SRHP|Vkl128_LINER      //
//˸
#define Vkl128_BLKCTL_OFF      0xF0  // ر˸
#define Vkl128_BLKCTL_05HZ     0xF1  // ˸ƵΪ0.5HZ
#define Vkl128_BLKCTL_1HZ      0xF2  // ˸ƵΪ1HZ
#define Vkl128_BLKCTL_2HZ      0xF3  // ˸ƵΪ2HZ
//ȫǿп,ʾڴ޹,ȫΪִ
#define Vkl128_APCTL_APON_ON   0xFE // ȫǿȫʾ_
#define Vkl128_APCTL_APON_OFF  0xFC // ȫǿȫʾ_
#define Vkl128_APCTL_APOFF_ON  0xFD // ȫǿйʾ_
#define Vkl128_APCTL_APOFF_OFF 0xFC // ȫǿйʾ_

//seg
#define 	Vkl128_SEGNUM				32

//¹ܽøݿͻƬӦ޸ 
#define Vkl128_SCL_PIN    BIT13
#define Vkl128_SCL_PORT   PA
#define Vkl128_SCL_IO     PA13

#define Vkl128_SDA_PIN    BIT15
#define Vkl128_SDA_PORT   PA
#define Vkl128_SDA_IO     PA15

//¹ܽݿͻƬӦ޸
#define Vkl128_SCL_H() 				Vkl128_SCL_IO = 1 
#define Vkl128_SCL_L() 				Vkl128_SCL_IO = 0 

#define Vkl128_SDA_H() 				Vkl128_SDA_IO = 1 
#define Vkl128_SDA_L() 				Vkl128_SDA_IO = 0 

#define Vkl128_GET_SDA() 			Vkl128_SDA_IO
//ƬSDAΪIOҪΪ
//ݿͻƬ޸
#define Vkl128_DIRDAT_PIN   	BIT0
#define Vkl128_DIRDAT_PORT  	PB
#define Vkl128_DIRDAT_IO    	PB0
#define Vkl128_DIRDAT1_PIN   	BIT12
#define Vkl128_DIRDAT1_PORT  	PA
#define Vkl128_DIRDAT1_IO    	PA12
#define Vkl128_SET_SDA_DIR() 	{\
	GPIO_SetMode(Vkl128_DIRDAT_PORT, Vkl128_DIRDAT_PIN, GPIO_MODE_OUTPUT);\
	GPIO_SetMode(Vkl128_DIRDAT1_PORT, Vkl128_DIRDAT1_PIN, GPIO_MODE_OUTPUT);\
}
#define Vkl128_SET_SDA_IN() 	{\
  Vkl128_DIRDAT_IO = 0;\
  Vkl128_DIRDAT1_IO = 0;\
}
#define Vkl128_SET_SDA_OUT() 	{\
 	Vkl128_DIRDAT_IO = 1;\
  Vkl128_DIRDAT1_IO = 1;\
}
/* Exported functions ------------------------------------------------------- */
void Vkl128_Init(void);
void Vkl128_DisAll(unsigned char dat);
void Vkl128_DisSegComOn(unsigned char seg,unsigned char com);
void Vkl128_DisSegComOff(unsigned char seg,unsigned char com);

void Vkl128_Main(void);
#endif  /*__VKl128_H*/

/************************END OF FILE****/
